TLM-2.0: tlm::tlm_generic_payload Class Reference

# tlm::tlm_generic_payload Class Reference

`#include <tlm_gp.h>`

Collaboration diagram for tlm::tlm_generic_payload:

[legend]

List of all members.

## Public Member Functions
| tlm_generic_payload ()
| tlm_generic_payload (tlm_mm_interface *mm)
void | acquire ()
void | release ()
int | get_ref_count () const
void | set_mm (tlm_mm_interface *mm)
bool | has_mm () const
void | reset ()
void | deep_copy_from (const tlm_generic_payload &other)
void | update_original_from (const tlm_generic_payload &other, bool use_byte_enable_on_read=true)
void | update_extensions_from (const tlm_generic_payload &other)
void | free_all_extensions ()
virtual | ~tlm_generic_payload ()
bool | is_read () const
void | set_read ()
bool | is_write () const
void | set_write ()
tlm_command | get_command () const
void | set_command (const tlm_command command)
sc_dt::uint64 | get_address () const
void | set_address (const sc_dt::uint64 address)
unsigned char * | get_data_ptr () const
void | set_data_ptr (unsigned char *data)
unsigned int | get_data_length () const
void | set_data_length (const unsigned int length)
bool | is_response_ok () const
bool | is_response_error () const
tlm_response_status | get_response_status () const
void | set_response_status (const tlm_response_status response_status)
std::string | get_response_string () const
unsigned int | get_streaming_width () const
void | set_streaming_width (const unsigned int streaming_width)
unsigned char * | get_byte_enable_ptr () const
void | set_byte_enable_ptr (unsigned char *byte_enable)
unsigned int | get_byte_enable_length () const
void | set_byte_enable_length (const unsigned int byte_enable_length)
void | set_dmi_allowed (bool dmi_allowed)
bool | is_dmi_allowed () const
template<typename T >
T * | set_extension (T *ext)
tlm_extension_base * | set_extension (unsigned int index, tlm_extension_base *ext)
template<typename T >
T * | set_auto_extension (T *ext)
tlm_extension_base * | set_auto_extension (unsigned int index, tlm_extension_base *ext)
template<typename T >
void | get_extension (T *&ext) const
template<typename T >
T * | get_extension () const
tlm_extension_base * | get_extension (unsigned int index) const
template<typename T >
void | clear_extension (const T *ext)
template<typename T >
void | clear_extension ()
template<typename T >
void | release_extension (T *ext)
template<typename T >
void | release_extension ()
void | resize_extensions ()

## Detailed Description

Definition at line 112 of file tlm_gp.h.

## Constructor & Destructor Documentation

tlm::tlm_generic_payload::tlm_generic_payload | ( |  | ) | `[inline]`

Definition at line 120 of file tlm_gp.h.

tlm::tlm_generic_payload::tlm_generic_payload | ( | tlm_mm_interface * | mm | ) | `[inline, explicit]`

Definition at line 136 of file tlm_gp.h.

virtual tlm::tlm_generic_payload::~tlm_generic_payload | ( |  | ) | `[inline, virtual]`

Definition at line 350 of file tlm_gp.h.

## Member Function Documentation

void tlm::tlm_generic_payload::acquire | ( |  | ) | `[inline]`

Definition at line 152 of file tlm_gp.h.

template<typename T >

void tlm::tlm_generic_payload::clear_extension | ( |  | ) | `[inline]`

Definition at line 561 of file tlm_gp.h.

template<typename T >

void tlm::tlm_generic_payload::clear_extension | ( | const T * | ext | ) | `[inline]`

Definition at line 552 of file tlm_gp.h.

void tlm::tlm_generic_payload::deep_copy_from | ( | const tlm_generic_payload & | other | ) | `[inline]`

Definition at line 211 of file tlm_gp.h.

void tlm::tlm_generic_payload::free_all_extensions | ( |  | ) | `[inline]`

Definition at line 335 of file tlm_gp.h.

sc_dt::uint64 tlm::tlm_generic_payload::get_address | ( |  | ) | const`[inline]`

Definition at line 368 of file tlm_gp.h.

unsigned int tlm::tlm_generic_payload::get_byte_enable_length | ( |  | ) | const`[inline]`

Definition at line 407 of file tlm_gp.h.

unsigned char* tlm::tlm_generic_payload::get_byte_enable_ptr | ( |  | ) | const`[inline]`

Definition at line 405 of file tlm_gp.h.

tlm_command tlm::tlm_generic_payload::get_command | ( |  | ) | const`[inline]`

Definition at line 364 of file tlm_gp.h.

unsigned int tlm::tlm_generic_payload::get_data_length | ( |  | ) | const`[inline]`

Definition at line 376 of file tlm_gp.h.

unsigned char* tlm::tlm_generic_payload::get_data_ptr | ( |  | ) | const`[inline]`

Definition at line 372 of file tlm_gp.h.

tlm_extension_base* tlm::tlm_generic_payload::get_extension | ( | unsigned int | index | ) | const`[inline]`

Definition at line 543 of file tlm_gp.h.

template<typename T >

T* tlm::tlm_generic_payload::get_extension | ( |  | ) | const`[inline]`

Definition at line 538 of file tlm_gp.h.

template<typename T >

void tlm::tlm_generic_payload::get_extension | ( | T *& | ext | ) | const`[inline]`

Definition at line 534 of file tlm_gp.h.

int tlm::tlm_generic_payload::get_ref_count | ( |  | ) | const`[inline]`

Definition at line 154 of file tlm_gp.h.

tlm_response_status tlm::tlm_generic_payload::get_response_status | ( |  | ) | const`[inline]`

Definition at line 382 of file tlm_gp.h.

std::string tlm::tlm_generic_payload::get_response_string | ( |  | ) | const`[inline]`

Definition at line 385 of file tlm_gp.h.

unsigned int tlm::tlm_generic_payload::get_streaming_width | ( |  | ) | const`[inline]`

Definition at line 401 of file tlm_gp.h.

bool tlm::tlm_generic_payload::has_mm | ( |  | ) | const`[inline]`

Definition at line 156 of file tlm_gp.h.

bool tlm::tlm_generic_payload::is_dmi_allowed | ( |  | ) | const`[inline]`

Definition at line 413 of file tlm_gp.h.

bool tlm::tlm_generic_payload::is_read | ( |  | ) | const`[inline]`

Definition at line 360 of file tlm_gp.h.

bool tlm::tlm_generic_payload::is_response_error | ( |  | ) | const`[inline]`

Definition at line 381 of file tlm_gp.h.

bool tlm::tlm_generic_payload::is_response_ok | ( |  | ) | const`[inline]`

Definition at line 380 of file tlm_gp.h.

bool tlm::tlm_generic_payload::is_write | ( |  | ) | const`[inline]`

Definition at line 362 of file tlm_gp.h.

void tlm::tlm_generic_payload::release | ( |  | ) | `[inline]`

Definition at line 153 of file tlm_gp.h.

template<typename T >

void tlm::tlm_generic_payload::release_extension | ( |  | ) | `[inline]`

Definition at line 577 of file tlm_gp.h.

template<typename T >

void tlm::tlm_generic_payload::release_extension | ( | T * | ext | ) | `[inline]`

Definition at line 569 of file tlm_gp.h.

void tlm::tlm_generic_payload::reset | ( |  | ) | `[inline]`

Definition at line 158 of file tlm_gp.h.

void tlm::tlm_generic_payload::resize_extensions | ( |  | ) | `[inline]`

Definition at line 608 of file tlm_gp.h.

void tlm::tlm_generic_payload::set_address | ( | const sc_dt::uint64 | address | ) | `[inline]`

Definition at line 369 of file tlm_gp.h.

tlm_extension_base* tlm::tlm_generic_payload::set_auto_extension | ( | unsigned int | index,
|  | tlm_extension_base * | ext |
| ) |  |  | `[inline]`

Definition at line 523 of file tlm_gp.h.

template<typename T >

T* tlm::tlm_generic_payload::set_auto_extension | ( | T * | ext | ) | `[inline]`

Definition at line 517 of file tlm_gp.h.

void tlm::tlm_generic_payload::set_byte_enable_length | ( | const unsigned int | byte_enable_length | ) | `[inline]`

Definition at line 408 of file tlm_gp.h.

void tlm::tlm_generic_payload::set_byte_enable_ptr | ( | unsigned char * | byte_enable | ) | `[inline]`

Definition at line 406 of file tlm_gp.h.

void tlm::tlm_generic_payload::set_command | ( | const tlm_command | command | ) | `[inline]`

Definition at line 365 of file tlm_gp.h.

void tlm::tlm_generic_payload::set_data_length | ( | const unsigned int | length | ) | `[inline]`

Definition at line 377 of file tlm_gp.h.

void tlm::tlm_generic_payload::set_data_ptr | ( | unsigned char * | data | ) | `[inline]`

Definition at line 373 of file tlm_gp.h.

void tlm::tlm_generic_payload::set_dmi_allowed | ( | bool | dmi_allowed | ) | `[inline]`

Definition at line 412 of file tlm_gp.h.

tlm_extension_base* tlm::tlm_generic_payload::set_extension | ( | unsigned int | index,
|  | tlm_extension_base * | ext |
| ) |  |  | `[inline]`

Definition at line 507 of file tlm_gp.h.

template<typename T >

T* tlm::tlm_generic_payload::set_extension | ( | T * | ext | ) | `[inline]`

Definition at line 501 of file tlm_gp.h.

void tlm::tlm_generic_payload::set_mm | ( | tlm_mm_interface * | mm | ) | `[inline]`

Definition at line 155 of file tlm_gp.h.

void tlm::tlm_generic_payload::set_read | ( |  | ) | `[inline]`

Definition at line 361 of file tlm_gp.h.

void tlm::tlm_generic_payload::set_response_status | ( | const tlm_response_status | response_status | ) | `[inline]`

Definition at line 383 of file tlm_gp.h.

void tlm::tlm_generic_payload::set_streaming_width | ( | const unsigned int | streaming_width | ) | `[inline]`

Definition at line 402 of file tlm_gp.h.

void tlm::tlm_generic_payload::set_write | ( |  | ) | `[inline]`

Definition at line 363 of file tlm_gp.h.

void tlm::tlm_generic_payload::update_extensions_from | ( | const tlm_generic_payload & | other | ) | `[inline]`

Definition at line 318 of file tlm_gp.h.

void tlm::tlm_generic_payload::update_original_from | ( | const tlm_generic_payload & | other,
|  | bool | use_byte_enable_on_read = `true` |
| ) |  |  | `[inline]`

Definition at line 266 of file tlm_gp.h.

The documentation for this class was generated from the following file:

- include/tlm/tlm_h/tlm_generic_payload/tlm_gp.h